package org.dromara.knowledge.service;

import com.baomidou.mybatisplus.extension.service.IService;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.knowledge.domain.KnowledgeRoleGroup;
import org.dromara.knowledge.domain.bo.KnowledgeRoleGroupBo;
import org.dromara.knowledge.domain.vo.KnowledgeRoleGroupVo;

import java.util.Collection;
import java.util.List;

/**
 * 知识库角色分组Service接口
 *
 * @author pengles
 */
public interface KnowledgeRoleGroupService extends IService<KnowledgeRoleGroup> {

    /**
     * 查询知识库角色分组
     */
    KnowledgeRoleGroupVo queryById(Long id);

    /**
     * 查询知识库角色分组列表
     */
    TableDataInfo<KnowledgeRoleGroupVo> queryPageList(KnowledgeRoleGroupBo bo, PageQuery pageQuery);

    /**
     * 查询知识库角色分组列表
     */
    List<KnowledgeRoleGroupVo> queryList(KnowledgeRoleGroupBo bo);

    /**
     * 新增知识库角色分组
     */
    Boolean insertByBo(KnowledgeRoleGroupBo bo);

    /**
     * 修改知识库角色分组
     */
    Boolean updateByBo(KnowledgeRoleGroupBo bo);

    /**
     * 校验并批量删除知识库角色分组
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 根据分组编码查询分组信息
     */
    KnowledgeRoleGroupVo queryByGroupCode(String groupCode);

    /**
     * 查询启用状态的分组列表
     */
    List<KnowledgeRoleGroupVo> queryEnabledList();

}